//
// $Id: test_profil.cpp 51 2006-06-09 19:54:01Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

#ifdef __BORLANDC__
#pragma hdrstop
#endif

//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdexcept>
#include "xy.h"

//---------------------------------------------------------------------
void test_profil(void)
{
	////////////////////////////////////////
	// Test der Profilverwaltung
	////////////////////////////////////////

	printf ("*************************************************************************\n");
	printf ("Test Profilverwaltung\n");

	printf ("Test Profile erzeugen:                                               ");

	TProfil *Profil1 = new TProfil(2502000);
	TProfil *Profil2 = new TProfil(2507000);

	Profil1->AddPoint(1, 2);
	Profil1->AddPoint(3, 2, 1);
	Profil1->AddPoint(6, 6, 2);

	Profil2->AddPoint(8, 9);
	Profil2->AddPoint(10, 13, 3);
	Profil2->AddPoint(12, 19);
	Profil2->AddPoint(14, 20);

	TProfil *Profil3 = new TProfil(Profil1);

	// Sonst wird es nicht in die ProfilListe aufgenommen (doppelte Station verboten)
	Profil3->Station = 1234000;

	if (Profil1->PointList->size() != 3)		printf("Failed\n");
	else if (Profil2->PointList->size() != 4)	printf("Failed\n");
	else if (Profil3->PointList->size() != 3)	printf("Failed\n");
	else										printf("Pass\n");


	////////////////////////////////////////
	////////////////////////////////////////

	printf ("Test Koordinaten ermitteln:                                          ");

	long X1 = 0;
	long Y1 = 0;
	Profil1->GetXY(0, &X1, &Y1);

	long X2 = 0;
	long Y2 = 0;
	Profil1->GetXY(1, &X2, &Y2);

	long X3 = 0;
	long Y3 = 0;
	Profil1->GetXY(3, &X3, &Y3);

	long X4 = 0;
	long Y4 = 0;
	Profil1->GetXY(45, &X4, &Y4);

	if (X1 != 1 || Y1 != 2)			printf("Failed\n");
	else if (X2 != 2 || Y2 != 2)	printf("Failed\n");
	else if (X3 != 4 || Y3 != 3)	printf("Failed\n");
	else if (X4 != 29 || Y4 != 36)	printf("Failed\n");
	else							printf("Pass\n");

	////////////////////////////////////////
	////////////////////////////////////////

	printf ("Test Profilliste:                                                    ");

	TProfil *Profil4 = new TProfil(1050000);

	Profil4->AddPoint(4, 2);
	Profil4->AddPoint(5, 3);
	Profil4->AddPoint(6, 4, 5);
	Profil4->AddPoint(7, 5);
	Profil4->AddPoint(8, 6);

	TProfil *Profil5 = new TProfil(1015000);

	Profil5->AddPoint(14, 22);
	Profil5->AddPoint(15, 23);
	Profil5->AddPoint(16, 24);
	Profil5->AddPoint(17, 25);
	Profil5->AddPoint(18, 26);

	TProfil *Profil6 = new TProfil(994000);

	Profil6->AddPoint(4, 2);
	Profil6->AddPoint(1, 2);
	Profil6->AddPoint(6, 4);
	Profil6->AddPoint(1, 2);
	Profil6->AddPoint(8, 6);

	TProfilList *ProfilList = new TProfilList;

	ProfilList->insert(Profil1);
	ProfilList->insert(Profil2);
	ProfilList->insert(Profil3);
	ProfilList->insert(Profil4);
	ProfilList->insert(Profil5);
	ProfilList->insert(Profil6);

	int Size1 = ProfilList->size();

	ProfilList->Clear();

	// Jetzt nochmal mit dynamisch erzeugt Pointern
	for (unsigned int i=0; i < 113; i++)
	{
		TProfil *Profil = new TProfil((i * 79) % 113);

		Profil->AddPoint(i, i+0, 11000);
		Profil->AddPoint(i, i+1, 22000);
		Profil->AddPoint(i, i+2, 33000);
		Profil->AddPoint(i, i+3, 44000);
		Profil->AddPoint(i, i+4, 55000);

		ProfilList->insert(Profil);
	}

	int Size2 = ProfilList->size();

	TProfil *Profil10 = new TProfil(100000);

	Profil10->AddPoint(101, 101, 101);
	Profil10->AddPoint(102, 102, 102);

	ProfilList->insert(Profil10);

	TProfil *Profil11 = new TProfil(110000);

	Profil11->AddPoint(111, 111, 111);
	Profil11->AddPoint(112, 112, 112);

	ProfilList->insert(Profil11);

	int Size3 = ProfilList->size();

	if (Size1 != 6)				printf("Failed\n");
	else if (Size2 != 113)		printf("Failed\n");
	else if (Size3 != 115)		printf("Failed\n");
	else						printf("Pass\n");

	printf ("*************************************************************************\n");
}

