//
// $Id: test_tri.cpp 49 2006-05-26 05:12:48Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

#ifdef __BORLANDC__
#pragma hdrstop
#endif

//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#define DGMFILE		"test_daten\\dgm_gross.xyz"
#else
#define DGMFILE		"test_daten/dgm_gross.xyz"
#endif

//---------------------------------------------------------------------------
#include <stdio.h>

#include "file.h"

#include "xy.h"
#include "quadtree.h"

//---------------------------------------------------------------------
void test_quadtree(void)
{
	////////////////////////////////////////
	// Test des QuadTre
	////////////////////////////////////////

	printf ("*************************************************************************\n");
	printf ("Test QuadTree\n");

	{
		printf ("Test QuadTree 1 Knoten:                                              ");

		// Zuerst einen paar Punkte generieren
		TNode *Node = new TNode(1, 1, 1, 0);

		long MinX = 0;
		long MaxX = 2;
		long MinY = 0;
		long MaxY = 2;

		TQuadTree<TNodeList, TNode> *QuadTree = new TQuadTree<TNodeList, TNode>(Node);

		TNode* FoundNode1 = QuadTree->Search(1, 1, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode2 = QuadTree->Search(2, 2, MinX, MaxX, MinY, MaxY);

		if (1 != QuadTree->ListAll())	printf("Failed\n");
		else if (!FoundNode1)			printf("Failed\n");
		else if (FoundNode2)			printf("Failed\n");
		else							printf("Pass\n");

		delete QuadTree;
		delete Node;
	}

	{
		printf ("Test QuadTree 4 Knoten:                                              ");

		// Zuerst einen paar Punkte generieren
		TNode *Node1 = new TNode(1, 1, 1, 0);
		TNode *Node2 = new TNode(1, 1, 2, 0);
		TNode *Node3 = new TNode(1, 2, 1, 0);
		TNode *Node4 = new TNode(1, 2, 2, 0);

		TQuadTree<TNodeList, TNode> *QuadTree = new TQuadTree<TNodeList, TNode>();

		long MinX = 0;
		long MaxX = 3;
		long MinY = 0;
		long MaxY = 5;

		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node1);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node2);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node3);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node4);

		TNode* FoundNode1 = QuadTree->Search(Node1->X, Node1->Y, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode2 = QuadTree->Search(Node2->X, Node2->Y, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode3 = QuadTree->Search(Node3->X, Node3->Y, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode4 = QuadTree->Search(Node4->X, Node4->Y, MinX, MaxX, MinY, MaxY);

		if (4 != QuadTree->ListAll())	printf("Failed\n");
		else if (!FoundNode1)			printf("Failed\n");
		else if (!FoundNode2)			printf("Failed\n");
		else if (!FoundNode3)			printf("Failed\n");
		else if (!FoundNode4)			printf("Failed\n");
		else							printf("Pass\n");

		delete QuadTree;
		delete Node1;
		delete Node2;
		delete Node3;
		delete Node4;
	}

	{
		printf ("Test QuadTree 7 Knoten:                                              ");

		// Zuerst einen paar Punkte generieren
		TNode *Node1 = new TNode(1, 1, 1, 0);
		TNode *Node2 = new TNode(1, 1, 2, 0);
		TNode *Node3 = new TNode(1, 2, 1, 0);
		TNode *Node4 = new TNode(1, 2, 2, 0);
		TNode *Node5 = new TNode(1, 2, 2, 0);
		TNode *Node6 = new TNode(1, 1, 2, 0);
		TNode *Node7 = new TNode(1, 2, 1, 0);

		long MinX = 0;
		long MaxX = 3;
		long MinY = 0;
		long MaxY = 5;

		TQuadTree<TNodeList, TNode> *QuadTree = new TQuadTree<TNodeList, TNode>();

		bool Insert1 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node1);
		bool Insert2 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node2);
		bool Insert3 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node3);
		bool Insert4 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node4);
		bool Insert5 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node5);
		bool Insert6 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node6);
		bool Insert7 = QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node7);

		if (4 != QuadTree->ListAll())	printf("Failed\n");
		else if (!Insert1)				printf("Failed\n");
		else if (!Insert2)				printf("Failed\n");
		else if (!Insert3)				printf("Failed\n");
		else if (!Insert4)				printf("Failed\n");
		else if (Insert5)				printf("Failed\n");
		else if (Insert6)				printf("Failed\n");
		else if (Insert7)				printf("Failed\n");
		else							printf("Pass\n");

		delete QuadTree;
		delete Node1;
		delete Node2;
		delete Node3;
		delete Node4;
		delete Node5;
		delete Node6;
		delete Node7;
	}

	{
		printf ("Test QuadTree 9 Knoten:                                              ");
		TNode *Node01 = new TNode(1, 1, 1, 0);
		TNode *Node02 = new TNode(2, 1, 2, 0);
		TNode *Node03 = new TNode(3, 1, 3, 0);
		TNode *Node04 = new TNode(4, 2, 1, 0);
		TNode *Node05 = new TNode(5, 2, 2, 0);
		TNode *Node06 = new TNode(6, 2, 3, 0);
		TNode *Node07 = new TNode(7, 3, 1, 0);
		TNode *Node08 = new TNode(8, 3, 2, 0);
		TNode *Node09 = new TNode(9, 3, 3, 0);

		long MinX = 1;
		long MaxX = 3;
		long MinY = 1;
		long MaxY = 3;

		TQuadTree<TNodeList, TNode> *QuadTree = new TQuadTree<TNodeList, TNode>();

		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node01);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node02);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node03);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node04);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node05);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node06);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node07);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node08);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node09);

		TNodeList*	FoundNodeList = new TNodeList();

		int AnzFound = QuadTree->SearchAll(2, 2, 2.0, FoundNodeList, MinX, MaxX, MinY, MaxY);

		if (9 != QuadTree->ListAll())	printf("Failed\n");
		else if (9 != AnzFound)			printf("Failed\n");
		else							printf("Pass\n");

		delete QuadTree;
		delete Node01;
		delete Node02;
		delete Node03;
		delete Node04;
		delete Node05;
		delete Node06;
		delete Node07;
		delete Node08;
		delete Node09;
	}

	{
		printf ("Test QuadTree 12 Knoten:                                             ");
		TNode *Node01 = new TNode(1, 1, 1, 0);
		TNode *Node02 = new TNode(2, 9, 1, 0);
		TNode *Node03 = new TNode(3, 9, 9, 0);
		TNode *Node04 = new TNode(4, 1, 9, 0);
		TNode *Node05 = new TNode(5, 4, 9, 0);
		TNode *Node06 = new TNode(6, 7, 9, 0);
		TNode *Node07 = new TNode(7, 7, 7, 0);
		TNode *Node08 = new TNode(8, 3, 4, 0);
		TNode *Node09 = new TNode(9, 7, 4, 0);
		TNode *Node10 = new TNode(10, 7, 6, 0);
		TNode *Node11 = new TNode(11, 3, 6, 0);
		TNode *Node12 = new TNode(12, 4, 5, 0);

		long MinX = 1;
		long MaxX = 9;
		long MinY = 1;
		long MaxY = 9;

		TQuadTree<TNodeList, TNode> *QuadTree = new TQuadTree<TNodeList, TNode>();

		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node01);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node02);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node03);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node04);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node05);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node06);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node07);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node08);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node09);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node10);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node11);
		QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node12);

		TNodeList*	FoundNodeList = new TNodeList();

		int AnzFound = QuadTree->SearchAll(8, 5, 8.0, FoundNodeList, MinX, MaxX, MinY, MaxY);

		if (12 != QuadTree->ListAll())	printf("Failed\n");
		else if (10 != AnzFound)		printf("Failed\n");
		else							printf("Pass\n");

		delete QuadTree;
		delete Node01;
		delete Node02;
		delete Node03;
		delete Node04;
		delete Node05;
		delete Node06;
		delete Node07;
		delete Node08;
		delete Node09;
		delete Node10;
		delete Node11;
		delete Node12;
	}

	{
		printf ("Test QuadTree 1126 Knoten:                                           ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE, NodeList, ElementList, 0, false, false, 1);

		TQuadTree<TNodeList, TNode> *QuadTree = new TQuadTree<TNodeList, TNode>();

		long MinX = 350000000;
		long MaxX = 350150000;
		long MinY = 587160000;
		long MaxY = 587400000;

		for (TNodeList::iterator i = NodeList->begin(); i != NodeList->end(); i++)
		{
			TNode *Node = *i;
			QuadTree->Insert(MinX, MaxX, MinY, MaxY, Node);
		}

		TNode* FoundNode1 = QuadTree->Search(350051407, 587273750, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode2 = QuadTree->Search(350039678, 587216726, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode3 = QuadTree->Search(350122901, 587269463, MinX, MaxX, MinY, MaxY);
		TNode* FoundNode4 = QuadTree->Search(350117145, 587279638, MinX, MaxX, MinY, MaxY);

		TNodeList*	FoundNodeList = new TNodeList();

		int AnzFound1 = QuadTree->SearchAll(350121497, 587287087, 2000.0, FoundNodeList, MinX, MaxX, MinY, MaxY);
		int AnzFound2 = QuadTree->SearchAll(350121497, 587287087, 4000.0, FoundNodeList, MinX, MaxX, MinY, MaxY);
		int AnzFound3 = QuadTree->SearchAll(350111497, 587277087, 1500.0, FoundNodeList, MinX, MaxX, MinY, MaxY);

		if (1126 != QuadTree->ListAll())	printf("Failed\n");
		else if (!FoundNode1)				printf("Failed\n");
		else if (!FoundNode2)				printf("Failed\n");
		else if (!FoundNode3)				printf("Failed\n");
		else if (!FoundNode4)				printf("Failed\n");
		else if (4 != AnzFound1)			printf("Failed\n");
		else if (15 != AnzFound2)			printf("Failed\n");
		else if (1 != AnzFound3)			printf("Failed\n");
		else								printf("Pass\n");

		delete QuadTree;
		delete ElementList;
		delete NodeList;
	}

	printf ("*************************************************************************\n");
}
