//
// $Id: test_tri.cpp 153 2010-05-07 16:54:36Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

#ifdef __BORLANDC__
#pragma hdrstop
#endif

//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#define DGMFILE1		"test_daten\\dgm.shp"
#define DGMFILE2		"test_daten\\dgm.grd"
#define DGMFILE3		"test_daten\\dgm.xyz"
#define DGMFILE4		"test_daten\\dgm_gross.xyz"
#define DGMFILE5		"test_daten\\dgm_ziemlich_gross.xyz"
#define DGMFILE6		"test_daten\\dgm2.shp"
#else
#define DGMFILE1		"test_daten/dgm.shp"
#define DGMFILE2		"test_daten/dgm.grd"
#define DGMFILE3		"test_daten/dgm.xyz"
#define DGMFILE4		"test_daten/dgm_gross.xyz"
#define DGMFILE5		"test_daten/dgm_ziemlich_gross.xyz"
#define DGMFILE6		"test_daten/dgm2.shp"
#endif

//---------------------------------------------------------------------------
#include <stdio.h>

#include "file.h"

#include "xy.h"
#include "tools.h"
#include "tri.h"

//---------------------------------------------------------------------
void test_tri(void)
{
	////////////////////////////////////////
	// Test der Triangulierung
	////////////////////////////////////////

	printf ("*************************************************************************\n");
	printf ("Test Triangulierung\n");

	{
		printf ("Test Triangulierung 3 Knoten:                                        ");

		// Zuerst ein paar Punkte generieren
		TNode *N01 = new TNode(1, 1, 1, 0);
		TNode *N02 = new TNode(2, 9, 1, 0);
		TNode *N03 = new TNode(3, 9, 9, 0);

		TNodeList *NodeList = new TNodeList();

		NodeList->Add(N01);
		NodeList->Add(N02);
		NodeList->Add(N03);

		TElementList *ElementList = new TElementList();

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 8)  	printf("Failed\n");
		else if (NodeList->size() != 7)	printf("Failed\n");
		else						   	printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 10 Knoten:                                       ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE3, NodeList, ElementList, 0, false, false, 1);

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 22)		printf("Failed\n");
		else if (NodeList->size() != 14)	printf("Failed\n");
		else						  		printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 12 Knoten:                                       ");

		TNode *N01 = new TNode(1, 1, 1, 0);
		TNode *N02 = new TNode(2, 9, 1, 0);
		TNode *N03 = new TNode(3, 9, 9, 0);
		TNode *N04 = new TNode(4, 1, 9, 0);
		TNode *N05 = new TNode(5, 4, 9, 0);
		TNode *N06 = new TNode(6, 7, 9, 0);
		TNode *N07 = new TNode(7, 7, 7, 0);
		TNode *N08 = new TNode(8, 3, 4, 0);
		TNode *N09 = new TNode(9, 7, 4, 0);
		TNode *N10 = new TNode(10, 7, 6, 0);
		TNode *N11 = new TNode(11, 3, 6, 0);
		TNode *N12 = new TNode(12, 4, 5, 0);

		TNodeList *NodeList = new TNodeList();

		NodeList->Add(N01);
		NodeList->Add(N02);
		NodeList->Add(N03);
		NodeList->Add(N04);
		NodeList->Add(N05);
		NodeList->Add(N06);
		NodeList->Add(N07);
		NodeList->Add(N08);
		NodeList->Add(N09);
		NodeList->Add(N10);
		NodeList->Add(N11);
		NodeList->Add(N12);

		TElementList *ElementList = new TElementList();

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 26)		printf("Failed\n");
		else if (NodeList->size() != 16)	printf("Failed\n");
		else								printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 114 Knoten:                                      ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE1, NodeList, ElementList, 0, false, false, 1);

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 230)		printf("Failed\n");
		else if (NodeList->size() != 118)	printf("Failed\n");
		else								printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 1126 Knoten:                                     ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE4, NodeList, ElementList, 0, false, false, 1);

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 2254)	printf("Failed\n");
		else if (NodeList->size() != 1130)	printf("Failed\n");
		else								printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 43332 Knoten:                                    ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE5, NodeList, ElementList, 0, false, false, 1);

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 86666)	printf("Failed\n");
		else if (NodeList->size() != 43336)	printf("Failed\n");
		else								printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 71250 Knoten:                                    ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE2, NodeList, ElementList, 0, false, false, 1);

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 142502)	printf("Failed\n");
		else if (NodeList->size() != 71254)	printf("Failed\n");
		else								printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	{
		printf ("Test Triangulierung 156249 Knoten:                                   ");

		TNodeList *NodeList = new TNodeList();
		TElementList *ElementList = new TElementList();

		LoadDGM(DGMFILE6, NodeList, ElementList, 0, false, false, 1);

		Triangulate(NodeList, ElementList, 0, 8);

		if (ElementList->size() != 312500)		printf("Failed\n");
		else if (NodeList->size() != 156253)	printf("Failed\n");
		else									printf("Pass\n");

		delete ElementList;
		delete NodeList;
	}

	printf ("*************************************************************************\n");
}
